import dabax
from string import *

st_test = 'Ni 10;O 10;Si 1;'
out_test = 'Al 0.5293;O 0.4707;'



def from_st(lista):
    lista = split(lista,';')
    summa = 0
    partiale = []
    st_out = ''
    for i in range(len(lista)):
        if lista[i] == '':
            del lista[i]
        else:
            Pmi = dabax.AtomicProperties(split(lista[i])[0],'AtomicMass')
            summa = summa + Pmi*atof(split(lista[i])[1])
            partiale.append(Pmi*atof(split(lista[i])[1]))
        
    for k in range(len(partiale)):
        st_out = st_out+str(split(lista[k])[0])+' '+str(round(partiale[k]/summa,4))+';'
    return st_out

def to_st(lista):
    lista = split(lista,';')
    summa = 0
    partiale = []
    st_out = ''
    mcm = []
    out_st0 = []
    for i in range(len(lista)):
        if lista[i] == '':
            del lista[i]
        else:
            Pmi = dabax.AtomicProperties(split(lista[i])[0],'AtomicMass')
            summa = summa + Pmi
            partiale.append(atof(split(lista[i])[1])/Pmi)
    if len(lista) == 1:
        return str(split(lista[0])[0])+' '+str(int(atof(split(lista[0])[1])))+';'
    else:
        for k in range(len(partiale)):
            partiale[k] = farey(partiale[k]*summa,20)
        for i in range(len(partiale)):
            mcm.append(partiale[i][1])
        mcm_out = reduce(lcm, mcm)
        for f in range(len(partiale)):
            out_st0.append(partiale[f][0]*mcm_out/partiale[f][1])
        for n in range(len(out_st0)) :
            st_out = st_out+str(split(lista[n])[0])+' '+str(out_st0[n]/Euclid(out_st0))+';'
        
        return st_out        

def farey(v, lim):
  '''Named after James Farey, an English surveyor.
  No error checking on args -- lim = max denominator,
  results are (numerator, denominator), (1,0) is infinity
  '''
  if v < 0:
    n,d = farey(-v, lim)
    return -n,d
  z = lim-lim	# get 0 of right type for denominator
  lower, upper = (z,z+1), (z+1,z)
  while 1:
    mediant = (lower[0] + upper[0]), (lower[1]+upper[1])
    if v * mediant[1] > mediant[0]:
        if lim < mediant[1]: return upper
        lower = mediant
    elif v * mediant[1] == mediant[0]:
        if lim >= mediant[1]: return mediant
        if lower[1] < upper[1]: return lower
        return upper
    else:
        if lim < mediant[1]: return lower
        upper = mediant


def gcd(a,b):
    return a if b==0 else gcd(b, a%b)

def lcm(a,b):
    return a*b/gcd(a,b)
    
def Euclid(*integers):
    if type(integers[0])==list or type(integers[0])==tuple:
	integers = integers[0]
    if len(integers) == 2:
	a,b = integers[0],integers[1]
	while b != 0:
		a,b = b, a%b
	return a
    else:
	return Euclid(integers[0],Euclid(integers[1:]))
	
#print to_st(from_st(st_test))
