# Modifica del file feffxxxx.dat sostituendo i parametri di riflettivita'


from string import *
from numpy import array
import Ifeffit
iff=Ifeffit.Ifeffit()

def feff_file(q,amp,fase,f_file,camp,mink,maxk,reff,const) :
    file = open(f_file,"r")
    c = 0
    cont = file.read()
    cont = split(cont,'\n')
    file.close()

    for line1 in cont :
        c = c+1
        line1 = split(line1)
        if line1[0]=="k" :
            break
    content = cont[:c]
    cont = cont[c:len(cont)-1]
    temp1=[]
    temp2=[]
    temp5=[]
    temp6=[]
    temp7=[]
    for i in range(len(cont)) :
        cont[i] = split(cont[i])
        temp1.append(atof(cont[i][0]))
        temp2.append(atof(cont[i][1]))
        temp5.append(atof(cont[i][4]))
        temp6.append(atof(cont[i][5]))
        temp7.append(atof(cont[i][6]))
    iff.put_array("temp._1",temp1)
    iff.put_array("temp.2",temp2)
    iff.put_array("temp.5",temp5)
    iff.put_array("temp.6",temp6)
    iff.put_array("temp.7",temp7)

# Calcolo le colonne da modificare x il file di feff

    iff.put_array("sp.q",q)
    iff.put_array("sp.chiq_mag",amp)
    iff.put_array("sp.chiq_pha",fase)
    sliceq = "set out.q=slice(sp.q,nofx(sp.q,"+str(mink)+"),nofx( sp.q,"+str(maxk)+"))"
    slicemag = "set out.mag=slice(sp.chiq_mag,nofx(sp.q,"+str(mink)+"),nofx( sp.q,"+str(maxk)+"))"
    slicepha = "set out.pha=slice(sp.chiq_pha,nofx(sp.q,"+str(mink)+"),nofx( sp.q,"+str(maxk)+"))"
    iff.ifeffit(sliceq)
    iff.ifeffit(slicemag)
    iff.ifeffit(slicepha)
    iff.ifeffit("set out.k= temp._1")
    iff.ifeffit("set out.realp=rebin(out.k,temp.7,out.q)")
    iff.ifeffit("set out.redf=rebin(out.k,temp.5,out.q)")
    iff.ifeffit("set out.lam= rebin(out.k,temp.6,out.q)")
    iff.ifeffit("set out.realf=rebin(out.k,temp.2,out.q)")
    ph = "feff.ph=out.pha-2*out.q*"+str(reff)+"-3/2*pi-out.realf"
    iff.ifeffit(ph)
    amp = "feff.amp=out.mag/out.redf*out.q*"+str(const)+"*exp(2*"+str(reff)+"/out.lam)"
    iff.ifeffit(amp)
    iff.ifeffit("set out.mag2=rebin(out.q,feff.amp,out.k)")
    iff.ifeffit("set out.pha2=rebin(out.q,feff.ph,out.k)")
    ampl  = iff.get_array("out.mag2")
    phase = iff.get_array("out.pha2")

# Scrivo il nuovo file feffxxxx.dat

    linea=[]
    linea0=[]
    for d in range(len(content)) :
        linea0.append(content[d]+'\n')
    for c in range(len(cont)) :
        amplitude = "%(ampiezza)1.4E" % {"ampiezza" : atof(ampl[c])}
        phash = "%(fase)1.4E" % {"fase" : atof(phase[c])}
        linea.append(' '+cont[c][0].rjust(6)+'  '+cont[c][1]+'  '+amplitude+'  '+phash+'  '+cont[c][4]+'  '+cont[c][5]+'  '+cont[c][6]+'\n') 
        linea[c]=replace(linea[c]," -","-")
    file = open(camp,"w")
    file.writelines(linea0)
    file.writelines(linea)
    file.close()

