import sys
from PyQt4 import QtGui, QtCore

class GuessInput(QtGui.QDialog):
    def __init__(self, parent = None):
        super(GuessInput,self).__init__(parent)
        self.inpGroup = QtGui.QGroupBox(self.tr('Fit Variable'))
        self.comboLabel = QtGui.QLabel('Select Var.')
        self.refCombo = QtGui.QComboBox()
        self.guessLabel = QtGui.QLabel('Guess')
        self.minLabel = QtGui.QLabel('Min')
        self.maxLabel = QtGui.QLabel('Max')
        self.guess = QtGui.QLineEdit()
        self.min = QtGui.QLineEdit()
        self.max = QtGui.QLineEdit()
        self.variable = QtGui.QLineEdit()

        self.groupLayout = QtGui.QGridLayout()
        self.groupLayout.addWidget(self.comboLabel, 0,0)
        self.groupLayout.addWidget(self.refCombo, 1,0)
        self.groupLayout.addWidget(self.variable, 2,0)
        self.groupLayout.addWidget(self.guessLabel, 0,1)
        self.groupLayout.addWidget(self.minLabel, 1,1)
        self.groupLayout.addWidget(self.maxLabel, 2,1)
        self.groupLayout.addWidget(self.guess, 0,2)
        self.groupLayout.addWidget(self.min, 1,2)
        self.groupLayout.addWidget(self.max, 2,2)
        self.inpGroup.setLayout(self.groupLayout)
        
        self.buttonGroup = QtGui.QGroupBox()
        self.buttonBox = QtGui.QDialogButtonBox(QtGui.QDialogButtonBox.Ok | QtGui.QDialogButtonBox.Cancel)
        self.connect(self.buttonBox, QtCore.SIGNAL('accepted()'), self, QtCore.SLOT('accept()'))
        self.connect(self.buttonBox, QtCore.SIGNAL('rejected()'), self, QtCore.SLOT('reject()'))
        self.buttonGroupLayout = QtGui.QVBoxLayout()
        self.buttonGroupLayout.addWidget(self.buttonBox)
        self.buttonGroup.setLayout(self.buttonGroupLayout)
        
        layout = QtGui.QVBoxLayout()
        layout.addWidget(self.inpGroup)
        layout.addWidget(self.buttonGroup)
        self.setLayout(layout)
        self.setWindowTitle('Variable Edit')
        

if __name__ == '__main__':
    app = QtGui.QApplication(sys.argv)
    qb = GuessInput()
    qb.show()
    sys.exit(app.exec_())
